AppTitle "ASCII Island"
SeedRnd(MilliSecs())

Global width, height, mode
Global frameTimer=CreateTimer(60)

;menu variables
Dim title$(4)
Global file
Local i
file=ReadFile("sys/title.txt")
For i=0 To 4
	title(i)=ReadLine(file)
Next
CloseFile(file)
Global cursorPos=0
Global cmd$=""
Global invalidCmd

;game variables
Global menu$="initMenu"
Global playerName$="Du"
Global score=0
Global countdown
Global gameOver, dimmedScreen
Global cheat$

Dim highscore$(9,1)
file=ReadFile("sys/highscore.txt")
For i=0 To 9
  highscore(i,0)=ReadLine(file) ;name
  highscore(i,1)=ReadLine(file) ;score
Next
CloseFile(file)

;game objects
Global cam, light
Global aircraft, speed#, cloudSprite, island, terrainTexture, water, waterTexture
Global balloon10, balloon25, balloon50, balloonTourist, facade

;images
Global hudBG

;fonts
Global font

Repeat
	Cls()
	WaitTimer(frameTimer)
	
	If menu="initMenu" Then
		EndGraphics
		Graphics 700,500,32,2
		SetBuffer BackBuffer()
    ClsColor 40,20,40
    SetFont LoadFont("Courier New",16)
		menu="menu"
    
    file=ReadFile("sys/name.txt")
    playerName=ReadLine(file)
    CloseFile(file)
	ElseIf menu="menu" Then
    Color 200,200,20
		For i=0 To 4
			Text 50,30+i*20,title(i)
		Next
		
		Console()
  ElseIf menu="highscore" Then
    Color 200,200,20
		For i=0 To 4
			Text 50,30+i*20,title(i)
		Next
    
    Color 97,176,21
    For i=0 To 9
      Text 350,170+i*26,highscore(i,0)+": "+highscore(i,1),350
    Next
    
    Color 255,62,81
    Text 350,450,"Drcke [Escape], um zurck ins Hauptmen zu gelangen.",350
    
    If KeyHit(1) Then FlushKeys() : menu="menu"
	ElseIf menu="initGame" Then
    EndGraphics
    
    file=ReadFile("sys/resolution.txt")
    width=ReadLine(file)
    height=ReadLine(file)
    CloseFile(file)
    file=ReadFile("sys/mode.txt")
    mode=ReadLine(file)
    CloseFile(file)
    
    Graphics3D width,height,32,mode
    SetBuffer BackBuffer()
    
    ;environment
    AmbientLight 200,200,200
    
    cam=CreateCamera()
    CameraClsColor cam,135,206,235
    
    light=CreateLight()
    RotateEntity light,0,30,0
    
    ;aircraft
    aircraft=LoadSprite("gfx/aircraft.png",2)
    EntityBox aircraft,0,0,0,1,1,1
    EntityType aircraft,1
    PositionEntity aircraft,64,10,2
    PositionEntity cam,64,10,0
    EntityParent cam,aircraft
    speed#=0.1
    If cheat="highspeed" Then speed=0.3
    
    ;water
    water=CreatePlane()
    waterTexture=LoadTexture("gfx/water.png")
    ScaleTexture waterTexture,20,20
    EntityTexture water,waterTexture
    
    ;island
    island=LoadTerrain("gfx/map"+Rand(1,5)+".png")
    terrainTexture=LoadTexture("gfx/terrain.png")
    ScaleTexture terrainTexture,10,10
    EntityTexture island,terrainTexture
    ScaleEntity island,1,5,1
    PositionEntity island,0,-0.1,0
    TerrainDetail island,3000,1
    TerrainShading island,1
    
    ;cloud
    cloudSprite=LoadSprite("gfx/cloud.png")
    HideEntity cloudSprite
    GenerateClouds()
    
    ;balloons
    balloon10=LoadSprite("gfx/balloon10.png",2)
    EntityType balloon10,2
    HideEntity balloon10
    balloon25=LoadSprite("gfx/balloon25.png",2)
    EntityType balloon25,2
    HideEntity balloon25
    balloon50=LoadSprite("gfx/balloon50.png",2)
    EntityType balloon50,2
    HideEntity balloon50
    balloonTourist=LoadSprite("gfx/balloonTourist.png")
    EntityType balloonTourist,2
    HideEntity balloonTourist
    
    ;house facade
    facade=LoadTexture("gfx/facade.png")
    
    ;hud
    hudBG=LoadImage("gfx/hud.png")
    MaskImage hudBG,255,255,255
    SetFont LoadFont("Courier New",46,1)
    
    ;game over screen
    dimmedScreen=CreateSprite()
    ScaleSprite dimmedScreen,5,5
    EntityColor dimmedScreen,0,0,0
    PositionEntity dimmedScreen,64,10,2
    EntityParent dimmedScreen,cam
    HideEntity dimmedScreen
    
    ;reset variables
    score=0
    If cheat="royalflush" Then score=10000
    countdown=MilliSecs()+120000
    If cheat="ihavetime" Then countdown=countdown+120000
    gameOver=0
    
		GenerateEnvironment()
		menu="game"
	ElseIf menu="game" Then
    UpdateWorld()
		RenderWorld()
		Controls()
		Collide()
		HUD()
	EndIf
	
	Flip 0
Forever

Function Controls()
  If(gameOver>MilliSecs()) Then
    EntityAlpha dimmedScreen,1-(Float(gameOver)-MilliSecs())/2500
    Text width/2,height/2,"GAME OVER",width/2,height/2
  ElseIf(gameOver>0 And gameOver<MilliSecs()) Then
    ;save highscore
    DebugLog "score: "+score
    
    Local i
    For i=0 To 9
      If(score>Int(highscore(i,1))) Then
        highscore(i,0)=playerName
        highscore(i,1)=score        
        Exit
      EndIf
    Next
    
    file=WriteFile("sys/highscore.txt")
    For i=0 To 9
      WriteLine(file,highscore(i,0))
      WriteLine(file,highscore(i,1))
    Next
    CloseFile(file)
    
    menu="initMenu"
  Else
    MoveEntity aircraft,0,0,speed
    TurnEntity aircraft,0,EntityRoll(aircraft)/40,0
    
    If KeyDown(203) Or KeyDown(30) Then TurnEntity aircraft,0,0,0.4
    If KeyDown(205) Or KeyDown(32) Then TurnEntity aircraft,0,0,-0.4
    If (KeyDown(200) Or KeyDown(17)) And EntityPitch(aircraft)<20 Then TurnEntity aircraft,0.3,0,0
    If (KeyDown(208) Or KeyDown(31)) And EntityPitch(aircraft)>-20 Then TurnEntity aircraft,-0.3,0,0
    
    If KeyHit(1) Then menu="initMenu"
    
    ;collision with terrain or water
    If EntityY(aircraft) <= TerrainY(island,EntityX(aircraft),EntityY(aircraft),EntityZ(aircraft)) Or EntityY(aircraft) <= 0 Then
      gameOver=MilliSecs()+1500
      ShowEntity dimmedScreen
    EndIf
    
    If countdown < MilliSecs() Then
      gameOver=MilliSecs()+1500
      ShowEntity dimmedScreen
    EndIf
  EndIf
End Function

Function GenerateClouds()
	Local i,cloud
	For i=1 To 100
		cloud=CopyEntity(cloudSprite)
    If cheat="smokingweed" Then EntityColor cloud,255,0,255 : CameraClsColor cam,100,0,100
		PositionEntity cloud,Rnd(10,100),Rnd(10,20),Rnd(10,100)
	Next
End Function

Function GenerateEnvironment()
	Local i, b10.Balloon, b25.Balloon, b50.Balloon, bTourist.Balloon, house.House
	
	For i=1 To 30
		b10.Balloon=New Balloon
		b10\num=10
		b10\obj=CopyEntity(balloon10)
		PositionEntity b10\obj,Rnd(10,118),Rnd(10,13),Rnd(10,118)
    EntityBox b10\obj,EntityX(b10\obj),EntityY(b10\obj),EntityZ(b10\obj),1,1,1
	Next
  
  For i=1 To 20
    b25.Balloon=New Balloon
		b25\num=25
		b25\obj=CopyEntity(balloon25)
    ScaleSprite b25\obj,0.5,0.5
		PositionEntity b25\obj,Rnd(10,118),Rnd(7,10),Rnd(10,118)
    EntityBox b25\obj,EntityX(b25\obj),EntityY(b25\obj),EntityZ(b25\obj),0.5,0.5,0.5
  Next
  
  For i=1 To 15
    b50.Balloon=New Balloon
		b50\num=50
		b50\obj=CopyEntity(balloon50)
    ScaleSprite b50\obj,0.25,0.25
		PositionEntity b50\obj,Rnd(10,118),Rnd(4,6),Rnd(10,118)
    EntityBox b50\obj,EntityX(b50\obj),EntityY(b50\obj),EntityZ(b50\obj),0.25,0.25,0.25
    
    bTourist.Balloon=New Balloon
		bTourist\num=-25
		bTourist\obj=CopyEntity(balloonTourist)
		PositionEntity bTourist\obj,Rnd(10,118),10,Rnd(10,118)
    EntityBox bTourist\obj,EntityX(bTourist\obj),EntityY(bTourist\obj),EntityZ(bTourist\obj),1,1,1
  Next
  
  For i=1 To 100
    house.House=New House
    house\obj=CreateCube()
    EntityType house\obj,3
    EntityBox house\obj,0,0,0,1,1,1
    ScaleEntity house\obj,Rnd(0.25,1.5),Rnd(1,3.5),Rnd(0.25,1.5)
    PositionEntity house\obj,Rnd(30,90),2,Rnd(30,90)
    EntityTexture house\obj,facade
    EntityColor house\obj,Rand(100,170),Rand(100,170),Rand(100,170)
  Next
End Function

Function Collide()
  Local balloon.Balloon
  
  Collisions 1,2,1,1 
	Local hitBalloon=EntityCollided(aircraft,2)
  
  If(hitBalloon) Then
    For balloon.Balloon=Each Balloon
      If(balloon\obj=hitBalloon) Then
        score=score+balloon\num
        If score<0 Then score=0
        FreeEntity balloon\obj
        Delete balloon
      EndIf
    Next
  EndIf
  
  Collisions 1,3,1,1
  Local hitHouse=EntityCollided(aircraft,3)
  If(hitHouse) Then
    gameOver=MilliSecs()+1500
    ShowEntity dimmedScreen
  EndIf
  
End Function

Function HUD()
  DrawImage hudBG,0,0
  
  Color 163,62,81
	Text 20,20,"Deine Punkte: "+score
  Text 20,60,"Beste Punkte: "+highscore(0,1)
  If countdown > MilliSecs() Then Text 20,100,"Zeit: "+(countdown-MilliSecs())/1000+" Sekunden"
End Function

Function Console()
	Local cursorSymbol$, key$
	;blinking cursor
	If(MilliSecs() Mod 1000 < 500) Then
		cursorSymbol="> " + cmd + "_"
	Else
		cursorSymbol="> " + cmd + " "
	EndIf
  Color 200,200,200
	Text 30+cursorPos,460,cursorSymbol
  
  Color 200,200,200
  Text 50,180,"Du musst mit einem ASCII-Flugzeug ber eine kleine Insel fliegen und"
  Text 50,200,"versuchen, in 2 Minuten so viele Ballons wie mglich einzusammeln."
  Text 50,220,"Wenn du in ein Gebude oder ins Wasser fliegst, hast du verloren."
  Color 50,150,50
  Text 50,250,"Du bekommst pro Ballon entweder 10, 25 oder 50 Punkte."
  Color 150,150,50
  Text 50,270,"Aber gib Acht auf die Touristen-Ballons, sie ziehen dir 25 Punkte ab!"
  Color 200,200,200
  Text 50,300,"Bitte tippe einen der folgenden Befehle ein:"
  Color 115,215,197
  Text 70,320,"play                        (Starte ein neues Spiel)"
  Text 70,340,"name [dein_name]            (Lege deinen Namen fr den HighScore fest)"
  Text 70,360,"highscore                   (Zeige den HighScore an)"
  Text 70,380,"resolution width,height     (Lege die Bildschirmauflsung fest)"
  Text 70,400,"screenmode [window|full]    (Lege den Bildschirmmodus fest)"
  Text 70,420,"quit                        (Beende das Spiel)"
  
  If invalidCmd+1500 > MilliSecs() Then
    Color 255,20,20
    Text 50,480,"Ungltiger Befehl"
  EndIf
	
	key=GetKey()
	If key>0 Then
		If key=8 Then
			If Len(cmd)>0 Then cmd=Left(cmd,Len(cmd)-1)
    ElseIf key=9 Then
      ;propose command
      If Instr("play",cmd)>0 Then
        cmd="play"
      ElseIf Instr("name",cmd) Then
        cmd="name"
      ElseIf Instr("highscore",cmd)>0 Then
        cmd="highscore"
      ElseIf Instr("resolution",cmd)>0 Then
        cmd="resolution"
      ElseIf Instr("screenmode",cmd)>0 Then
        cmd="screenmode"
      ElseIf Instr("quit",cmd)>0 Or Instr("exit",cmd)>0 Then
        cmd="quit"
      EndIf
    ElseIf key=13 Then
      ;execute command
      If cmd="play" Then
        menu="initGame"
      ElseIf Instr(cmd,"name ")>0 Then
        playerName=Mid(cmd,6)
        
        file=WriteFile("sys/name.txt")
        WriteLine(file,playerName)
        CloseFile(file)
      ElseIf cmd="highscore" Then
        menu="highscore"
      ElseIf cmd="quit" Or cmd="exit" Then
        End
      ElseIf Instr(cmd,"resolution ")>0 Then
        Local delimiter=Instr(cmd,",")
        Local newWidth$=Mid(cmd,12,delimiter-12)
        Local newHeight$=Mid(cmd,delimiter+1)
        
        file=WriteFile("sys/resolution.txt")
        WriteLine(file,newWidth)
        WriteLine(file,newHeight)
        CloseFile(file)
      ElseIf Instr(cmd,"screenmode ")>0 Then
        Local newMode$=Mid(cmd,12)
        
        If(newMode="window" Or newMode="full") Then
          file=WriteFile("sys/mode.txt")
          If(newMode="window") Then
            WriteLine(file,"2")
          Else
            WriteLine(file,"0")
          EndIf
          CloseFile(file)
        Else
          invalidCmd=MilliSecs()
        EndIf
      Else
        cheat=cmd
        invalidCmd=MilliSecs()
      EndIf
      
      cmd=""
		Else
			cmd=cmd+Chr(key)
		EndIf
	EndIf
End Function

Type Balloon
	Field num
	Field obj
End Type

Type House
  Field obj
End Type
;~IDEal Editor Parameters:
;~C#Blitz3D