Global currentX = 0
Global currentY = 0
Global currentD = DRIGHT



	Global maxReachedLevel = 15
	Global maxLevel = 20
	Global wordsFound
	
	
	Global levelBoardActionDescr$ = ""
	Global levelBoardLevelTitle$ = ""
	
	
Function game(currentLevel)


	SetBuffer BackBuffer()
	
	moveLevelBoard(currentLevel, 0)
	
	Repeat
	
		Cls
			SetFont fontBold
			Color 255, 255, 55
			Center 40, "Buchstabensalat"
			Rect xr / 2 - 100, 70, 200, 1
			
			SetFont fontNormal
			Color 222, 222, 222
			Center 100, "LEVEL " + currentLevel
			drawLevelDescription currentLevel
			
			SetFont fontNormal
			Color 255, 255, 255
			Center 350, "[ENTER] Spielen"
			If currentLevel > 1 Then Text 100, 350, "[<]"
			If currentLevel < maxReachedLevel Then Text xr - 100 - StringWidth("[>]"), 350, "[>]"
			Center 400, "[ESC] Hauptmenue"
			
			SetFont fontSmall
			Color 122, 122, 122
			Text 0, yr - 16, "Ein Spiel von SpionAtom fuer den BCC #92 - Maerz 2o17 - www.blitzforum.de"

			
			If KeyHit(KEY_LEFT) Then
				If currentLevel > 0 Then
					moveLevelBoard  currentLevel, -1
					currentLevel = currentLevel - 1
				End If
				FlushKeys()
			End If
			
			If KeyHit(KEY_RIGHT) Or solved Then
				If currentLevel < maxReachedLevel Then
					moveLevelBoard  currentLevel, 1
					currentLevel = currentLevel + 1
				End If
				FlushKeys()
			End If
			
			solved = False
			If KeyHit(28) Or KeyHit(156) Then
				solved = mainloop(currentLevel)
				FlushKeys()
			End If

		
		Flip(0)
		WaitTimer fpsTimer
	
	Until KeyHit(1)


End Function




;Fancy Animation fr das Levelboard am Anfang.
;Gibt actiondescription zurck.
Function moveLevelBoard(currentLevel, moveTo)

	toLevel = currentLevel + moveTo
	currentLevelText$ = "LEVEL " + currentLevel
	toLevelText$ = "LEVEL " + toLevel
	finalToLevelX = Center(yr, toLevelText)
	currentLevelX = Center(yr, currentLevelText)

	Viewport 0, 100, xr, 250
	SetFont fontNormal
	Color 222, 222, 222

	If moveTo >= 0 Then ;scroll from right to left
		x = xr
		ac# = 1
		While x > finalToLevelX
			ac = ac * 1.5
			x = x - ac
			If x < finalToLevelX Then x = finalToLevelX
		
			Cls
			Text x, 100, toLevelText
			If moveTo > 0 Then Text currentLevelX - ac, 100, currentLevelText
			Flip(0)
			WaitTimer fpsTimer
		Wend
	
	End If
	
	If moveTo = -1 Then ;scroll from left to right
		
		x = -StringWidth(toLevelText)
		ac# = 1
		While x < finalToLevelX
			ac = ac * 1.5
			x = x + ac
			If x > finalToLevelX Then x = finalToLevelX
		
			Cls
			Text x, 100, toLevelText
			Text x + currentLevelX + StringWidth(toLevelText), 100, currentLevelText
			Flip(0)
			WaitTimer fpsTimer
		Wend
		
		Viewport 0, 0, xr, yr
		
	End If
	
	Viewport 0, 0, xr, yr

End Function
	
Function mainloop(currentLevel)

	currentX = 0
	currentY = 0
	currentD = DRIGHT
	makeLevel currentLevel
	
	SetBuffer BackBuffer()
	Repeat
		keyhitup = KeyHit(200)
		keyhitdown = KeyHit(208)
		keyhitleft = KeyHit(203)
		keyhitright = KeyHit(205)
		keyhitchar = GetKey()
		;Buchstaben
		If (keyhitchar >= Asc("A") And keyhitchar <= Asc("Z")) Or (keyhitchar >= Asc("a") And keyhitchar <= Asc("z")) Then
			If GridArray(currentX, currentY) > -1 Then
				GridArray(currentX, currentY) = Asc(Upper(Chr(keyhitchar)))
			End If
			moveCursor currentD
		End If
		
		;Leetaste
		If keyhitchar = Asc(" ") Then
			If GridArray(currentX, currentY) > -1 Then
				GridArray(currentX, currentY) = 0
			End If
			moveCursor currentD
		End If
		
		;Backspace
		If keyhitchar = 8 Then
			If currentD = DUP Then moveCursor DDOWN
			If currentD = DDOWN Then moveCursor DUP
			If currentD = DLEFT Then moveCursor DRIGHT
			If currentD = DRIGHT Then moveCursor DLEFT

			If GridArray(currentX, currentY) > -1 Then
				GridArray(currentX, currentY) = 0
			End If
		End If
	
		If KeyDown(42) Or KeyDown(54) Then ;shift
			If keyhitup Then ;up
				currentD = DUP
			End If
			If keyhitdown Then ;down
				currentD = DDOWN
			End If
			If keyhitleft Then ;left
				currentD = DLEFT
			End If
			If keyhitright Then ;right
				currentD = DRIGHT
			End If
		Else ;no shift
			If keyhitup Then ;up
				moveCursor DUP
			End If
			If keyhitdown Then ;down
				moveCursor DDOWN
			End If
			If keyhitleft Then ;left
				moveCursor DLEFT
			End If
			If keyhitright Then ;right
				moveCursor DRIGHT
			End If
		End If
		
		If KeyHit(28) Or KeyHit(156) Then ;next free field
			
			Repeat
				currentX = currentX + 1
				If currentX >= Grid\w Then
					currentX = 0
					currentY = currentY + 1
					If currentY >= Grid\h Then
						currentX = 0
						currentY = 0
					End If
				End If
			Until GridArray(currentX, currentY) >= 0
		
		End If
	
		Cls
			SetFont fontNormal
			Color 222, 222, 222
			Text 10, 10, "LEVEL " + currentLevel
			Text 10, 40, getLevelTitle(currentLevel)
			
			drawGrid currentLevel
			drawCursor
			drawWordList
			
			If wordsFound = words Then ;level solved
				drawGrid
				drawVictory
				Flip()
				Repeat
					If (MilliSecs() / 1000) Mod 2 = 0 Then
						Color 0, 0, 0
						Rect 10, 40, xr, 30
					Else
						Color 255, 255, 255
						SetFont FontNormal
						Text 10, 40, "[ENTER] um fortzufahren"
					End If
					Flip(0)
					WaitTimer fpsTimer
				Until KeyHit(28) Or KeyHit(156) Or KeyHit(1)
				FlushKeys
				
				Return 1
			End If
		
		Flip(0)
		WaitTimer fpsTimer
	
	Until KeyHit(1)
	Return 0

End Function


Function drawWordList()

	wordsFound = 0
	SetFont fontNormal
	For i = 0 To words - 1
		w$ = wordList[i]
		If wordFound(w) Then
			wordsFound = wordsFound + 1
			Color 255, 255, 0
		Else
			Color 155, 55, 55
		End If
		Text xr - StringWidth(wordList[i]) - 10, yr - (i + 1) * 32, wordList[i]
	Next
End Function

Function wordFound(w$)
	w$ = Upper(w$)
	L = Len(w)
	
	For x = 0 To Grid\w - 1
	For y = 0 To Grid\h - 1
		If Abs(GridArray(x, y)) = Asc(Mid(w, 1, 1)) Then
		
		
			;Check: DRIGHT
			found = True
			If x + L - 1 < Grid\w Then
				For i = 0 To L - 1
					If Abs(GridArray(x + i, y)) <> Asc(Mid(w, i + 1, 1)) Then found = False
				Next
				If found Then Return True
			End If
			
			;Check: DDOWN
			found = True
			If y + L - 1 < Grid\h Then
				For i = 0 To L - 1
					If Abs(GridArray(x, y + i)) <> Asc(Mid(w, i + 1, 1)) Then found = False
				Next
				If found Then Return True
			End If
			
			;Check: DLEFT
			found = True
			If x - L + 1 >= 0 Then
				For i = 0 To L - 1
					If Abs(GridArray(x - i, y)) <> Asc(Mid(w, i + 1, 1)) Then found = False
				Next
				If found Then Return True
			End If

			;Check: DDOWN
			found = True
			If y - L + 1 >= 0 Then
				For i = 0 To L - 1
					If Abs(GridArray(x, y - i)) <> Asc(Mid(w, i + 1, 1)) Then found = False
				Next
				If found Then Return True
			End If
		
		End If
	
	Next
	Next
		

	Return False


End Function


Function moveCursor(dir)
	Select dir
		Case DUP:
			currentY = currentY - 1
			If currentY < 0 Then currentY = Grid\h - 1
			DebugLog("up")
		Case DDOWN:
			currentY = currentY + 1
			If currentY > Grid\h - 1 Then currentY = 0
			DebugLog("down")		
		Case DLEFT:
			currentX = currentX - 1 
			If currentX < 0 Then currentX = Grid\w - 1
			DebugLog("left")
		Case DRIGHT:
			currentX = currentX + 1
			If currentX > Grid\w - 1 Then currentX = 0
			DebugLog("right")
	End Select

End Function
	
Function drawCursor()

	x = Grid\x + currentX * Grid\s
	y = Grid\y + currentY * Grid\s

	Color 250, 250, 50
	Rect x + 2, y + 2, Grid\s - 4, Grid\s - 4, 0
	drawArrow x + 0.5 * Grid\s, y + 0.5 * Grid\s, currentD

End Function

Function drawArrow(x, y, d)

	Select currentD
		Case DUP:
			Color 0, 0, 0
			Rect x - 2, y - 7, 5, 14
			Color 250, 250, 50
			Line x, y - 5, x, y + 5
			Line x - 1, y - 4, x + 1, y - 4
		Case DDOWN:
			Color 0, 0, 0
			Rect x - 2, y - 7, 5, 14
			Color 250, 250, 50
			Line x, y - 5, x, y + 5
			Line x - 1, y + 4, x + 1, y + 4
		Case DLEFT:
			Color 0, 0, 0
			Rect x - 7, y - 2, 14, 5
			Color 250, 250, 50
			Line x - 5, y, x + 5, y
			Line x - 4, y - 1, x - 4, y + 1
		Case DRIGHT:
			Color 0, 0, 0
			Rect x - 7, y - 2, 14, 5
			Color 250, 250, 50
			Line x - 5, y, x + 5, y
			Line x + 4, y - 1, x + 4, y + 1
	End Select

End Function
	
Function drawGrid(noCoordinates = True)

	SetFont fontBold
	For x = 0 To Grid\w - 1
	For y = 0 To Grid\h - 1
		If mouseInRect(Grid\x + x * Grid\s, Grid\y + y * Grid\s, Grid\s, Grid\s) And MouseDown(1) Then ;Cursor setzen per Maus
			currentX = x
			currentY = y
		End If
		Color 100, 100, 100
		Rect Grid\x + x * Grid\s, Grid\y + y * Grid\s, Grid\s, Grid\s, 0
		
		If GridArray(x, y) = -1 Then ;solids
			Color 63, 63, 63
			Rect Grid\x + x * Grid\s + 1, Grid\y + y * Grid\s + 1, Grid\s - 2, Grid\s - 2, 1
		Else If  GridArray(x, y) >= -90 And GridArray(x, y) <= -65 Then ;solid characters
			Color 122, 122, 122
			c$ = Chr(-GridArray(x, y))
			Text Grid\x + x * Grid\s + (Grid\s - StringWidth(c)) / 2, Grid\y + y * Grid\s + (Grid\s - StringHeight(c)) / 2, c
		
		Else If GridArray(x, y) >= 65 And GridArray(x, y) <= 90 Then ;characters
			Color 155, 155, 0
			c$ = Chr(GridArray(x, y))
			Text Grid\x + x * Grid\s + (Grid\s - StringWidth(c)) / 2, Grid\y + y * Grid\s + (Grid\s - StringHeight(c)) / 2, c
		
		End If

		If Not noCoordinates Then
			Color 22, 255, 22
			SetFont fontTiny
			Text Grid\x + x * Grid\s + 1, Grid\y + y * Grid\s + 1, x + ", " + y
			SetFont fontBold
		End If
		
		
	Next
	Next

End Function


Function drawVictory()
	
	Color 255, 255, 100
	For i = 0 To 2
		drawFieldBackground 1 + i, 3
		drawFieldBackground 5 + i, 3
		drawFieldBackground 5 + i, 7
		If i < 2 Then drawFieldBackground 9 + i, 7
		If i < 2 Then drawFieldBackground 12 + i, 7
	Next
	For i = 0 To 4
		drawFieldBackground 2, 3 + i
		drawFieldBackground 5, 3 + i
		drawFieldBackground 7, 3 + i
		drawFieldBackground 9, 3 + i
		drawFieldBackground 12, 3 + i
	Next
	
	SetFont fontBold
	For x = 0 To Grid\w - 1
	For y = 0 To Grid\h - 1
		Color 100, 100, 100
		Rect Grid\x + x * Grid\s, Grid\y + y * Grid\s, Grid\s, Grid\s, 0
		
		If GridArray(x, y) = -1 Then ;solids
		Else If  GridArray(x, y) >= -90 And GridArray(x, y) <= -65 Then ;solid characters
			Color 122, 122, 122
			c$ = Chr(-GridArray(x, y))
			Text Grid\x + x * Grid\s + (Grid\s - StringWidth(c)) / 2, Grid\y + y * Grid\s + (Grid\s - StringHeight(c)) / 2, c
		
		Else If GridArray(x, y) >= 65 And GridArray(x, y) <= 90 Then ;characters
			Color 155, 155, 0
			c$ = Chr(GridArray(x, y))
			Text Grid\x + x * Grid\s + (Grid\s - StringWidth(c)) / 2, Grid\y + y * Grid\s + (Grid\s - StringHeight(c)) / 2, c
		End If

	Next
	Next		

	
End Function

Function drawFieldBackground(x, y)
	Rect Grid\x + x * Grid\s + 1 , Grid\y + y * Grid\s + 1, Grid\s - 2, Grid\s - 2, 1
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D