Function getLevelTitle$(n)

	Select n
		Case 0: Return "Editor"
		Case 1: Return "Aller Anfang ist leicht"
		Case 2: Return "Unveraenderlich"
		Case 3: Return "Komfort"
		Case 4: Return "Spiegelverkehrt"
		Case 5: Return "Rauf und Runter"
		Case 6: Return "Komfort II"
		Case 7: Return "Alles ist mglich"
		Case 8: Return "Kompakt I"
		Case 9: Return "Blitzbasic"
		Case 10: Return "Kollegen"
		Case 11: Return "Diamant"
		Case 12: Return "Falle"
	End Select

End Function

Function drawLevelDescription(n)
	SetFont fontNormal
	Color 200, 200, 200
	Center 130, getLevelTitle(n)
	SetFont fontSmall
	Color 177, 177, 177
	Select n
		Case 0
			Center 170, "Hier kann man einfach Woerter eingeben."
			Center 190, "Total inoffiziell diese Ebene."
	
		Case 1
			Center 170, "Bewege den Cursor mit den PFEIL-Tasten in die freien Felder"
			Center 190, "und tippe die vorgegebenen Begriffe dort ein."
			Center 210, "Alle Woerter muessen Platz finden."
			
		Case 2
			Center 170, "Manchmal sind bereits Buchstaben im Feld eingetragen."
			Center 190, "Diese kann man nicht ueberschreiben."
			
		Case 3
			Center 170, "Wenn du ENTER drueckst, dann landest du automatisch beim"
			Center 190, "naechsten freien Feld."

		Case 4
			Center 170, "Manchmal muessen Begriffe SPIEGELVERKEHRT eingegeben werden"
			Center 190, "damit es passt."
	
		Case 5
			Center 170, "Ebenso muss man manchmal RAUF und RUNTER schreiben"
			Center 190, "damit es passt."
		
		Case 6
			Center 170, "Einen Trick gibt es noch: Wenn du die SHIFT-Taste"
			Center 190, "und dazu eine PFEIL-Taste drueckst, dann aenderst du"
			Center 210, "damit die Schreibrichtung."
			Center 230, "Diese erkennst du an dem kleinen Pfeil."
			
		Case 7
			Center 170, "Manchmal wird ein Buchstabe doppelt verwendet"
			Center 190, "Findest du die richtige Lsung?"
			
		Case 8
			Center 170, "Kompakt und gar nicht mehr so leicht"
			
		Case 9
			Center 170, "Ein paar Blitzbasic-Befehle."
			Center 190, "Findest du die richtige Lsung?"
			
		Case 10
			Center 170, "Kollegen von der QA"
			
		Case 11
			Center 170, "Raetsel in Diamantform"
			
		Case 11
			Center 170, "It's a trap!"
		
	End Select
	

End Function


Function makeLevel(n)

	Select n
	
		Case 0
			words = 99
			fillGrid 0
	
		Case 1
			words = 2
			wordList[0] = "Aller"
			wordList[1] = "Anfang"
			fillGrid SOLID
			fillHorizontal 5, 3, 5
			fillHorizontal 7, 5, 6
			
		Case 2
			words = 4
			wordList[0] = "ist"
			wordList[1] = "immer"
			wordList[2] = "noch"
			wordList[3] = "leicht"
			fillGrid SOLID
			fillHorizontal 2, 2, 3
			fillHorizontal 3, 3, 5
			fillHorizontal 4, 4, 4
			fillHorizontal 5, 5, 6
			setSolidChar 2, 2, "i"
			setSolidChar 4, 3, "m"
			setSolidChar 6, 4, "c"
			setSolidChar 8, 5, "c"
			
		Case 3
			words = 3
			wordList[0] = "Enter"
			wordList[1] = "Return"
			wordList[2] = "Eingabe"
			fillGrid SOLID
			fillHorizontal 2, 2, 5
			fillHorizontal 6, 4, 6
			fillHorizontal 3, 6, 7

		Case 4
			words = 2
			wordList[0] = "Links"
			wordList[1] = "Rechts"
			fillGrid SOLID
			fillHorizontal 2, 5, 11
			setSolidChar 6, 5, "L"

		Case 5
			words = 2
			wordList[0] = "Rauf"
			wordList[1] = "Runter"
			
			fillGrid SOLID
			fillHorizontal 5, 5, 4
			fillVertical 7, 4, 6
			
		Case 6
			words = 4
			wordList[0] = "OSTEN"
			wordList[1] = "SUEDEN"
			wordList[2] = "WESTEN"
			wordList[3] = "NORDEN"
			fillGrid SOLID
			fillHorizontal 6, 3, 5
			fillVertical 10, 4, 6
			fillHorizontal 5, 9, 6
			fillVertical 5, 4, 6
		Case 7
			words = 4
			wordList[0] = "Halsband"
			wordList[1] = "Hamster"
			wordList[2] = "Haende"
			wordList[3] = "Hardware"
			fillGrid SOLID
			fillHorizontal 7, 5, 8
			fillHorizontal 0, 5, 8
			fillVertical 7, 0, 12
			
		Case 8
			words = 7
			wordList[0] = "Mord"
			wordList[1] = "Aber"
			wordList[2] = "Hund"
			wordList[3] = "Nena"		
			wordList[4] = "Hand"
			wordList[5] = "Nano"
			wordList[6] = "Maid"
			fillGrid SOLID
			fillHorizontal 6, 2, 4
			fillHorizontal 6, 3, 4
			fillHorizontal 6, 4, 4
			fillHorizontal 6, 5, 4
			
		Case 9
			words = 8
			wordList[0] = "Image"
			wordList[1] = "cls"
			wordList[2] = "graphics"
			wordList[3] = "color"		
			wordList[4] = "string"
			wordList[5] = "print"
			wordList[6] = "global"
			wordList[7] = "screen"
			fillGrid SOLID
			fillHorizontal 2, 5, 10
			fillVertical 4, 0, 11
			fillVertical 6, 1, 5
			fillVertical 8, 5, 5
			fillVertical 10, 5, 6
			fillVertical 11, 0, 6
			setSolidChar 4, 5, "S"
			
		Case 10
			words = 7
			wordList[0] = "Anika"
			wordList[1] = "Apostolis"
			wordList[2] = "Florian"
			wordList[3] = "Justus"		
			wordList[4] = "Sascha"
			wordList[5] = "Thomas"
			wordList[6] = "QA"
			
			fillGrid SOLID
			fillHorizontal 2, 3, 9
			fillHorizontal 2, 8, 9
			fillVertical 2, 3, 6
			fillVertical 5, 3, 6
			fillVertical 7, 1, 7
			fillVertical 10, 3, 6
			
		Case 11
			words = 7
			wordList[0] = "Die"
			wordList[1] = "Diamant"
			wordList[2] = "Dreck"
			wordList[3] = "Braue"		
			wordList[4] = "Wrack"
			wordList[5] = "Seemann"
			wordList[6] = "Braut"
			fillGrid SOLID
			fillHorizontal 7, 2, 1
			fillHorizontal 6, 3, 3
			fillHorizontal 5, 4, 5
			fillHorizontal 4, 5, 7
			fillHorizontal 5, 6, 5
			fillHorizontal 6, 7, 3
			fillHorizontal 7, 8, 1
			setSolidChar 7, 5, "M"
			
		Case 12
			words = 8
			wordList[0] = "Wiese"
			wordList[1] = "dreist"
			wordList[2] = "Leiter"
			wordList[3] = "Steil"		
			wordList[4] = "Stein"
			wordList[5] = "Reis"
			wordList[6] = "Teil"
			wordList[7] = "sein"
			fillGrid SOLID
			fillHorizontal 3, 1, 6
			fillHorizontal 5, 2, 5
			fillHorizontal 4, 3, 7
			fillHorizontal 3, 4, 6
			fillHorizontal 5, 5, 2
			fillHorizontal 8, 5, 1
			setSolidChar 7, 5, "E"
	End Select

End Function

Function setSolidChar(x, y, char$)

	GridArray(x, y) = -Asc(Upper(char$))

End Function

Function fillGrid(value)

	For x = 0 To Grid\w - 1
	For y = 0 To Grid\h - 1
		GridArray(x, y) = value
	Next
	Next
	
End Function


Function fillHorizontal(x, y, l, value = 0)
	For i = 0 To l - 1
		GridArray(x + i, y) = value
	Next
End Function

Function fillVertical(x, y, l, value = 0)
	For i = 0 To l - 1
		GridArray(x, y + i) = value
	Next
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D
;~IDEal Editor Parameters:
;~C#Blitz3D